/* de10d.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static doublereal c_b19 = 1.;
static integer c__10 = 10;

/* Subroutine */ int de10d_c(S_fp f, integer *m, doublereal *xn,
        doublereal *yn, doublereal *xk, doublereal *hmin, doublereal *eps,
        doublereal *p, doublereal *h__, doublereal *y, doublereal *ra,
        integer *ierr)
{
    /* Initialized data */

    static doublereal zero = 0.;
    static doublereal p5 = .5;
    static doublereal op5 = 1.5;
    static doublereal three = 3.;
    static doublereal four = 4.;
    static doublereal e5 = 5e-5;

    /* System generated locals */
    integer i__1, i__2;
    doublereal d__1, d__2;

    /* Builtin functions */
    double d_sign(doublereal *, doublereal *);

    /* Local variables */
    static doublereal e;
    static integer i__, j;
    static doublereal q, r__, x;
    extern /* Subroutine */ int utde11_c(integer *, integer *);
    static doublereal h3;
    static logical be, bh, br, bx;
    static doublereal hs;
    static integer sw;
    static doublereal xs;
    static integer ib1, ib2, ijk0, ijk1, ijk2;

    /* Parameter adjustments */
    --yn;
    --y;
    --ra;

    /* Function Body */
    *ierr = 0;
    i__1 = *m;
    for (i__ = 1; i__ <= i__1; ++i__) {
/* L1: */
        y[i__] = yn[i__];
    }
    if (*xn == *xk) {
        goto L23;
    }
    e5 = *eps * 5.;
    ib1 = *m + *m;
    ib2 = ib1 + *m;
    bh = TRUE_;
    br = TRUE_;
    bx = TRUE_;

    d__1 = abs(*h__);
    d__2 = *xk - *xn;
    *h__ = d_sign(&d__1, &d__2);
    x = *xn;
L2:
    xs = x;
    i__1 = *m;
    for (j = 1; j <= i__1; ++j) {
        ijk0 = *m + j;
        ra[ijk0] = y[j];
/* L3: */
    }
L4:
    hs = *h__;
    q = x + *h__ - *xk;
    be = TRUE_;
    if (! (*h__ > zero && q >= zero || *h__ < zero && q <= zero)) {
        goto L5;
    }
    *h__ = *xk - x;
    br = FALSE_;
L5:
    h3 = *h__ / three;

    for (sw = 1; sw <= 5; ++sw) {
        (*f)(&x, &y[1], &ra[1], m);
        i__1 = *m;
        for (i__ = 1; i__ <= i__1; ++i__) {
            q = h3 * ra[i__];
            ijk0 = *m + i__;
            ijk1 = ib1 + i__;
            ijk2 = ib2 + i__;
            switch (sw) {
                case 1:  goto L6;
                case 2:  goto L7;
                case 3:  goto L8;
                case 4:  goto L9;
                case 5:  goto L10;
            }
L6:
            r__ = q;
            ra[ijk1] = q;
            goto L11;
L7:
            r__ = p5 * (q + ra[ijk1]);
            goto L11;
L8:
            r__ = three * q;
            ra[ijk2] = r__;
            r__ = (r__ + ra[ijk1]) * .375;
            goto L11;
L9:
            r__ = ra[ijk1] + four * q;
            ra[ijk1] = r__;
            r__ = op5 * (r__ - ra[ijk2]);
            goto L11;
L10:
            r__ = p5 * (q + ra[ijk1]);
            q = (d__1 = r__ + r__ - op5 * (q + ra[ijk2]), abs(d__1));
L11:
            y[i__] = ra[ijk0] + r__;
            if (sw != 5) {
                goto L15;
            }

            e = (d__1 = y[i__], abs(d__1));
            r__ = e5;
            if (e >= *p) {
                r__ = e * e5;
            }

            if (q < r__) {
                goto L14;
            }
            if (! bx) {
                goto L21;
            }
            br = TRUE_;
            bh = FALSE_;
            *h__ = p5 * *h__;
            if (abs(*h__) >= *hmin) {
                goto L12;
            }

            *h__ = d_sign(&c_b19, h__) * *hmin;
            bx = FALSE_;
L12:
            i__2 = *m;
            for (j = 1; j <= i__2; ++j) {
                ijk0 = *m + j;
                y[j] = ra[ijk0];
/* L13: */
            }
            x = xs;
            goto L4;
L14:
            if (q >= r__ * .03125) {
                be = FALSE_;
            }
L15:
            ;
        }
        switch (sw) {
            case 1:  goto L16;
            case 2:  goto L19;
            case 3:  goto L17;
            case 4:  goto L18;
            case 5:  goto L19;
        }
L16:
        x += h3;
        goto L19;
L17:
        x += p5 * h3;
        goto L19;
L18:
        x += p5 * *h__;
L19:
        ;
    }

    if (! (be && bh && br)) {
        goto L20;
    }
    *h__ += *h__;
    bx = TRUE_;
L20:
    bh = TRUE_;
    if (br) {
        goto L2;
    }
    *h__ = hs;
    goto L23;
L21:
    *ierr = 65;
    goto L22;
L22:
    utde11_c(ierr, &c__10);
L23:
    return 0;
} /* de10d_c */
